=== modified file 'ChangeLog'
--- ChangeLog	2008-08-14 21:24:49 +0000
+++ ChangeLog	2008-11-11 05:58:19 +0000
@@ -1,3 +1,87 @@
+2008-10-16  Dalibor Topic  <robilad@kaffe.org>
+
+	* Makefile.am (pscan, flawfinder, rats, splint): Fixed to work when
+	builddir != srcdir.
+
+2008-10-16  Dalibor Topic  <robilad@kaffe.org>
+
+	* m4/ax_cflags_gcc_option.m4, m4/ax_cflags_warn_all.m4: 
+	Added new files from autoconf-archive.
+	* Makefile.am (AM_CFLAGS): Removed.
+	* configure.ac (AX_CFLAGS_WARN_ALL, AX_CFLAGS_GCC_OPTION) Added.
+	(fastjar_warn_cflags) Removed.
+
+2008-10-16  Dalibor Topic  <robilad@kaffe.org>
+
+	* jargrep.c, shift.c: Add guards for inclusion of unistd.h.
+	shift.c: Include config.h.
+
+2008-10-12  Dalibor Topic  <robilad@kaffe.org>
+
+	* Makefile.am (AM_CPPFLAGS): Added generated headers from
+	gnulib. Fix for fastjar bug #20061.
+
+2008-10-12  Dalibor Topic  <robilad@kaffe.org>
+
+	* jartool.c (exit_on_error): New function.
+	(main, get_next_arg, looks_like_dir, make_manifest,
+	add_to_jar_with_dir, add_to_jar, add_file_to_jar, 
+	create_central_header, extract_jar, list_jar, consume,
+	add_array_to_jar, get_index_entry) Use exit_on_error,
+	and handle ftrucate and write error conditions.
+
+2008-09-17  Dalibor Topic  <robilad@kaffe.org>
+
+	* jargrep.c (check_crc, check_sig): Use C99's uint32_t instead of ub4.
+
+2008-09-17  Dalibor Topic  <robilad@kaffe.org>
+
+	* jartool.c (extract_jar): Use C99's uint32_t instead of ub4.
+ 
+2008-09-17  Dalibor Topic  <robilad@kaffe.org>
+
+	* jartool.c (make_manifest): Initialize mod_time before use.
+
+2008-09-17  Xerxes Rnby  <xerxes@zafena.se>
+
+        * jartool.c (extract_jar): Corrected size passed to realloc
+        to prevent memory overwrite. Reported as Debian bug #499015.
+        Fixed memory leak.
+
+2008-09-15  Dalibor Topic  <robilad@kaffe.org>
+
+	* jartool.c (make_manifest): Only create META-INF dir when a new 
+	manifest is created, not on updates. Reported as Debian bug #489418.
+
+2008-09-14  Dalibor Topic  <robilad@kaffe.org>
+
+	* configure.ac, fastjar.texi, README, NEWS: Bumped version up to 0.97.
+
+2008-09-14  Dalibor Topic  <robilad@kaffe.org>
+
+	* lib/snprintf.h, lib/string.h: Removed unused files.
+
+2008-09-14  Dalibor Topic  <robilad@kaffe.org>
+
+	* lib/alloca_.h, lib/getopt_.h, lib/stdbool_.h, lib/stdint_.h,
+	lib/stdio_.h, lib/string_.h, lib/unistd_.h, lib/wchar_.h,
+	lib/wctype_.h: Removed no longer used files.
+
+2008-09-14  Dalibor Topic  <robilad@kaffe.org>
+
+	* lib/wctype.in.h, lib/wchar.in.h, lib/unistd.in.h, lib/string.in.h, 
+	lib/stdlib.in.h, lib/stdio.in.h, lib/stdint.in.h, lib/stdbool.in.h, 
+	lib/getopt.in.h, lib/float.in.h,  lib/float+.h, lib/alloca.in.h:
+	Added missing files.
+
+2008-09-14  Dalibor Topic  <robilad@kaffe.org>
+
+	* lib/.cvsignore : Removed.
+
+2008-09-14  Dalibor Topic  <robilad@kaffe.org>
+
+	* Makefile.am (LDADD): Fixed build on cygwin.
+
 2008-08-14  Dalibor Topic  <robilad@kaffe.org>
 
 	* NEWS: Updated for Joshua Sumali's fix.

=== modified file 'Makefile.am'
--- Makefile.am	2008-08-14 21:24:49 +0000
+++ Makefile.am	2008-11-11 05:58:19 +0000
@@ -3,10 +3,9 @@
 SUBDIRS = lib
 ACLOCAL_AMFLAGS = -I m4
 
-AM_CPPFLAGS = -I. -I$(top_srcdir) -I$(top_srcdir)/lib
-AM_CFLAGS = @fastjar_warn_cflags@
+AM_CPPFLAGS = -I. -I$(top_srcdir) -I$(top_srcdir)/lib -I$(top_builddir)/lib
 AM_LDFLAGS = -no-undefined
-LDADD = $(ZLIBS) lib/libgnu.la libfastjar_convenience.la 
+LDADD = lib/libgnu.la libfastjar_convenience.la $(ZLIBS)
 
 bin_PROGRAMS = fastjar grepjar
 
@@ -60,17 +59,22 @@
 
 # Support for static checkers
 pscan:
-	$(PSCAN) $(SOURCES)
+	for i in $(libfastjar_convenience_la_SOURCES) \
+		$(fastjar_SOURCES) $(grepjar_SOURCES); do \
+		$(PSCAN) $(top_srcdir)/$$i ; \
+	done
 
 flawfinder:
-	$(FLAWFINDER) $(SOURCES)
+	$(FLAWFINDER) $(top_srcdir)
 
 rats:
-	$(RATS) $(SOURCES)
+	$(RATS) $(top_srcdir)
 
-SPLINT_FLAGS=-I . -I $(srcdir)/lib -DHAVE_CONFIG_H +posixlib +weak
+SPLINT_FLAGS=-I . -I $(srcdir)/lib -I $(srcdir) -DHAVE_CONFIG_H -DPRIx32= -warnposix +weak
 splint:
-	$(SPLINT) $(SPLINT_FLAGS) $(libfastjar_convenience_la_SOURCES)
-	$(SPLINT) $(SPLINT_FLAGS) $(fastjar_SOURCES)
-	$(SPLINT) $(SPLINT_FLAGS) $(grepjar_SOURCES)
+	for i in $(libfastjar_convenience_la_SOURCES) \
+		$(fastjar_SOURCES) $(grepjar_SOURCES); do \
+		$(SPLINT) $(SPLINT_FLAGS) $(top_srcdir)/$$i ; \
+	done
+
 

=== modified file 'Makefile.in'
--- Makefile.in	2008-08-14 21:24:49 +0000
+++ Makefile.in	2008-11-11 05:58:19 +0000
@@ -44,6 +44,8 @@
 	ltmain.sh missing texinfo.tex
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
 am__aclocal_m4_deps = $(top_srcdir)/m4/alloca.m4 \
+	$(top_srcdir)/m4/ax_cflags_gcc_option.m4 \
+	$(top_srcdir)/m4/ax_cflags_warn_all.m4 \
 	$(top_srcdir)/m4/codeset.m4 $(top_srcdir)/m4/eoverflow.m4 \
 	$(top_srcdir)/m4/extensions.m4 $(top_srcdir)/m4/float_h.m4 \
 	$(top_srcdir)/m4/getopt.m4 $(top_srcdir)/m4/glibc21.m4 \
@@ -89,13 +91,13 @@
 fastjar_OBJECTS = $(am_fastjar_OBJECTS)
 fastjar_LDADD = $(LDADD)
 am__DEPENDENCIES_1 =
-fastjar_DEPENDENCIES = $(am__DEPENDENCIES_1) lib/libgnu.la \
-	libfastjar_convenience.la
+fastjar_DEPENDENCIES = lib/libgnu.la libfastjar_convenience.la \
+	$(am__DEPENDENCIES_1)
 am_grepjar_OBJECTS = jargrep.$(OBJEXT)
 grepjar_OBJECTS = $(am_grepjar_OBJECTS)
 grepjar_LDADD = $(LDADD)
-grepjar_DEPENDENCIES = $(am__DEPENDENCIES_1) lib/libgnu.la \
-	libfastjar_convenience.la
+grepjar_DEPENDENCIES = lib/libgnu.la libfastjar_convenience.la \
+	$(am__DEPENDENCIES_1)
 DEFAULT_INCLUDES = -I.@am__isrc@
 depcomp = $(SHELL) $(top_srcdir)/depcomp
 am__depfiles_maybe = depfiles
@@ -450,7 +452,6 @@
 docdir = @docdir@
 dvidir = @dvidir@
 exec_prefix = @exec_prefix@
-fastjar_warn_cflags = @fastjar_warn_cflags@
 gl_LIBOBJS = @gl_LIBOBJS@
 gl_LTLIBOBJS = @gl_LTLIBOBJS@
 gltests_LIBOBJS = @gltests_LIBOBJS@
@@ -485,10 +486,9 @@
 top_srcdir = @top_srcdir@
 SUBDIRS = lib
 ACLOCAL_AMFLAGS = -I m4
-AM_CPPFLAGS = -I. -I$(top_srcdir) -I$(top_srcdir)/lib
-AM_CFLAGS = @fastjar_warn_cflags@
+AM_CPPFLAGS = -I. -I$(top_srcdir) -I$(top_srcdir)/lib -I$(top_builddir)/lib
 AM_LDFLAGS = -no-undefined
-LDADD = $(ZLIBS) lib/libgnu.la libfastjar_convenience.la 
+LDADD = lib/libgnu.la libfastjar_convenience.la $(ZLIBS)
 noinst_LTLIBRARIES = libfastjar_convenience.la
 libfastjar_convenience_la_SOURCES = \
 	argv.c \
@@ -516,7 +516,9 @@
 
 TEXI2POD = perl $(srcdir)/texi2pod.pl
 POD2MAN = pod2man --center="GNU" --release=@VERSION@
-SPLINT_FLAGS = -I . -I $(srcdir)/lib -DHAVE_CONFIG_H +posixlib +weak
+
+#SPLINT_FLAGS=-I . -I $(srcdir)/lib -I $(srcdir) -DHAVE_CONFIG_H +posixlib +weak
+SPLINT_FLAGS = -I . -I $(srcdir)/lib -I $(srcdir) -DHAVE_CONFIG_H -DPRIx32= -warnposix +weak
 all: config.h
 	$(MAKE) $(AM_MAKEFLAGS) all-recursive
 
@@ -1346,17 +1348,21 @@
 
 # Support for static checkers
 pscan:
-	$(PSCAN) $(SOURCES)
+	for i in $(libfastjar_convenience_la_SOURCES) \
+		$(fastjar_SOURCES) $(grepjar_SOURCES); do \
+		$(PSCAN) $(top_srcdir)/$$i ; \
+	done
 
 flawfinder:
-	$(FLAWFINDER) $(SOURCES)
+	$(FLAWFINDER) $(top_srcdir)
 
 rats:
-	$(RATS) $(SOURCES)
+	$(RATS) $(top_srcdir)
 splint:
-	$(SPLINT) $(SPLINT_FLAGS) $(libfastjar_convenience_la_SOURCES)
-	$(SPLINT) $(SPLINT_FLAGS) $(fastjar_SOURCES)
-	$(SPLINT) $(SPLINT_FLAGS) $(grepjar_SOURCES)
+	for i in $(libfastjar_convenience_la_SOURCES) \
+		$(fastjar_SOURCES) $(grepjar_SOURCES); do \
+		$(SPLINT) $(SPLINT_FLAGS) $(top_srcdir)/$$i ; \
+	done
 # Tell versions [3.59,3.63) of GNU make to not export all variables.
 # Otherwise a system limit (for SysV at least) may be exceeded.
 .NOEXPORT:

=== modified file 'NEWS'
--- NEWS	2008-08-14 21:24:49 +0000
+++ NEWS	2008-11-11 05:58:19 +0000
@@ -1,5 +1,10 @@
+New in release 0.97
+-------------------
+
+* Build fix for Cygwin.
+
 New in release 0.96
-------------------------------------
+-------------------
 
 * Added support for -J and @file options.
 

=== modified file 'README'
--- README	2008-08-14 21:24:49 +0000
+++ README	2008-11-11 05:58:19 +0000
@@ -1,4 +1,4 @@
-FastJar 0.96 (unreleased)
+FastJar 0.97
 =============================
 
 FastJar is an attempt at creating a feature-for-feature copy of Sun's JDK's

=== modified file 'aclocal.m4'
--- aclocal.m4	2008-08-14 21:24:49 +0000
+++ aclocal.m4	2008-11-11 05:58:19 +0000
@@ -896,6 +896,8 @@
 ]) # _AM_PROG_TAR
 
 m4_include([m4/alloca.m4])
+m4_include([m4/ax_cflags_gcc_option.m4])
+m4_include([m4/ax_cflags_warn_all.m4])
 m4_include([m4/codeset.m4])
 m4_include([m4/eoverflow.m4])
 m4_include([m4/extensions.m4])

=== modified file 'configure'
--- configure	2008-08-14 21:24:49 +0000
+++ configure	2008-11-11 05:58:19 +0000
@@ -1,6 +1,6 @@
 #! /bin/sh
 # Guess values for system-dependent variables and create Makefiles.
-# Generated by GNU Autoconf 2.61 for fastjar 0.96.
+# Generated by GNU Autoconf 2.61 for fastjar 0.97.
 #
 # Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
 # 2002, 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
@@ -721,8 +721,8 @@
 # Identity of this package.
 PACKAGE_NAME='fastjar'
 PACKAGE_TARNAME='fastjar'
-PACKAGE_VERSION='0.96'
-PACKAGE_STRING='fastjar 0.96'
+PACKAGE_VERSION='0.97'
+PACKAGE_STRING='fastjar 0.97'
 PACKAGE_BUGREPORT=''
 
 ac_unique_file="jartool.h"
@@ -877,7 +877,6 @@
 PSCAN
 RATS
 SPLINT
-fastjar_warn_cflags
 ZLIBS
 GL_COND_LIBTOOL_TRUE
 GL_COND_LIBTOOL_FALSE
@@ -1602,7 +1601,7 @@
   # Omit some internal or obsolete options to make the list less imposing.
   # This message is too long to be a string in the A/UX 3.1 sh.
   cat <<_ACEOF
-\`configure' configures fastjar 0.96 to adapt to many kinds of systems.
+\`configure' configures fastjar 0.97 to adapt to many kinds of systems.
 
 Usage: $0 [OPTION]... [VAR=VALUE]...
 
@@ -1672,7 +1671,7 @@
 
 if test -n "$ac_init_help"; then
   case $ac_init_help in
-     short | recursive ) echo "Configuration of fastjar 0.96:";;
+     short | recursive ) echo "Configuration of fastjar 0.97:";;
    esac
   cat <<\_ACEOF
 
@@ -1776,7 +1775,7 @@
 test -n "$ac_init_help" && exit $ac_status
 if $ac_init_version; then
   cat <<\_ACEOF
-fastjar configure 0.96
+fastjar configure 0.97
 generated by GNU Autoconf 2.61
 
 Copyright (C) 1992, 1993, 1994, 1995, 1996, 1998, 1999, 2000, 2001,
@@ -1790,7 +1789,7 @@
 This file contains any messages produced by compilers while
 running configure, to aid debugging if configure makes a mistake.
 
-It was created by fastjar $as_me 0.96, which was
+It was created by fastjar $as_me 0.97, which was
 generated by GNU Autoconf 2.61.  Invocation command line was
 
   $ $0 $@
@@ -2502,7 +2501,7 @@
 
 # Define the identity of the package.
  PACKAGE='fastjar'
- VERSION='0.96'
+ VERSION='0.97'
 
 
 cat >>confdefs.h <<_ACEOF
@@ -5768,13 +5767,13 @@
 else
   lt_cv_nm_interface="BSD nm"
   echo "int some_variable = 0;" > conftest.$ac_ext
-  (eval echo "\"\$as_me:5771: $ac_compile\"" >&5)
+  (eval echo "\"\$as_me:5770: $ac_compile\"" >&5)
   (eval "$ac_compile" 2>conftest.err)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:5774: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
+  (eval echo "\"\$as_me:5773: $NM \\\"conftest.$ac_objext\\\"\"" >&5)
   (eval "$NM \"conftest.$ac_objext\"" 2>conftest.err > conftest.out)
   cat conftest.err >&5
-  (eval echo "\"\$as_me:5777: output\"" >&5)
+  (eval echo "\"\$as_me:5776: output\"" >&5)
   cat conftest.out >&5
   if $GREP 'External.*some_variable' conftest.out > /dev/null; then
     lt_cv_nm_interface="MS dumpbin"
@@ -6884,7 +6883,7 @@
   ;;
 *-*-irix6*)
   # Find out which ABI we are using.
-  echo '#line 6887 "configure"' > conftest.$ac_ext
+  echo '#line 6886 "configure"' > conftest.$ac_ext
   if { (eval echo "$as_me:$LINENO: \"$ac_compile\"") >&5
   (eval $ac_compile) 2>&5
   ac_status=$?
@@ -8541,11 +8540,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8544: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8543: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8548: \$? = $ac_status" >&5
+   echo "$as_me:8547: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -8865,11 +8864,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8868: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8867: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>conftest.err)
    ac_status=$?
    cat conftest.err >&5
-   echo "$as_me:8872: \$? = $ac_status" >&5
+   echo "$as_me:8871: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s "$ac_outfile"; then
      # The compiler can only warn and ignore the option if not recognized
      # So say no if there are warnings other than the usual output.
@@ -8970,11 +8969,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:8973: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:8972: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:8977: \$? = $ac_status" >&5
+   echo "$as_me:8976: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -9025,11 +9024,11 @@
    -e 's:.*FLAGS}\{0,1\} :&$lt_compiler_flag :; t' \
    -e 's: [^ ]*conftest\.: $lt_compiler_flag&:; t' \
    -e 's:$: $lt_compiler_flag:'`
-   (eval echo "\"\$as_me:9028: $lt_compile\"" >&5)
+   (eval echo "\"\$as_me:9027: $lt_compile\"" >&5)
    (eval "$lt_compile" 2>out/conftest.err)
    ac_status=$?
    cat out/conftest.err >&5
-   echo "$as_me:9032: \$? = $ac_status" >&5
+   echo "$as_me:9031: \$? = $ac_status" >&5
    if (exit $ac_status) && test -s out/conftest2.$ac_objext
    then
      # The compiler can only warn and ignore the option if not recognized
@@ -11786,7 +11785,7 @@
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 11789 "configure"
+#line 11788 "configure"
 #include "confdefs.h"
 
 #if HAVE_DLFCN_H
@@ -11886,7 +11885,7 @@
   lt_dlunknown=0; lt_dlno_uscore=1; lt_dlneed_uscore=2
   lt_status=$lt_dlunknown
   cat > conftest.$ac_ext <<_LT_EOF
-#line 11889 "configure"
+#line 11888 "configure"
 #include "confdefs.h"
 
 #if HAVE_DLFCN_H
@@ -12142,6 +12141,631 @@
 
 
 
+{ echo "$as_me:$LINENO: checking CFLAGS for maximum warnings" >&5
+echo $ECHO_N "checking CFLAGS for maximum warnings... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_warn_all+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_warn_all="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic  % -Wall"          "-xstrconst % -v"             "-std1      % -verbose -w0 -warnprotos"    "-qlanglvl=ansi % -qsrcmsg -qinfo=all:noppt:noppc:noobs:nocnd"    "-ansi -ansiE % -fullwarn"    "+ESlit     % +w1"            "-Xc        % -pvctl,fullmsg"    "-h conform % -h msglevel 2"    #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_warn_all=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_warn_all" >&5
+echo "${ECHO_T}$ac_cv_cflags_warn_all" >&6; }
+case ".$ac_cv_cflags_warn_all" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)
+ ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_warn_all " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_warn_all") >&5
+  (: CFLAGS does contain $ac_cv_cflags_warn_all) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_warn_all\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_warn_all") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_warn_all"
+   fi
+ ;;
+esac
+
+{ echo "$as_me:$LINENO: checking CFLAGS for gcc -pedantic" >&5
+echo $ECHO_N "checking CFLAGS for gcc -pedantic... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_gcc_option__pedantic+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_gcc_option__pedantic="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic -Werror % -pedantic"     "-pedantic % -pedantic %% no, obsolete"     #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_gcc_option__pedantic=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_gcc_option__pedantic" >&5
+echo "${ECHO_T}$ac_cv_cflags_gcc_option__pedantic" >&6; }
+case ".$ac_cv_cflags_gcc_option__pedantic" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)  ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_gcc_option__pedantic " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_gcc_option__pedantic") >&5
+  (: CFLAGS does contain $ac_cv_cflags_gcc_option__pedantic) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_gcc_option__pedantic\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__pedantic") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__pedantic"
+   fi
+ ;;
+esac
+
+{ echo "$as_me:$LINENO: checking CFLAGS for gcc -W" >&5
+echo $ECHO_N "checking CFLAGS for gcc -W... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_gcc_option__W+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_gcc_option__W="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic -Werror % -W"     "-pedantic % -W %% no, obsolete"     #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_gcc_option__W=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_gcc_option__W" >&5
+echo "${ECHO_T}$ac_cv_cflags_gcc_option__W" >&6; }
+case ".$ac_cv_cflags_gcc_option__W" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)  ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_gcc_option__W " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_gcc_option__W") >&5
+  (: CFLAGS does contain $ac_cv_cflags_gcc_option__W) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_gcc_option__W\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__W") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__W"
+   fi
+ ;;
+esac
+
+{ echo "$as_me:$LINENO: checking CFLAGS for gcc -Wextra" >&5
+echo $ECHO_N "checking CFLAGS for gcc -Wextra... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_gcc_option__Wextra+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_gcc_option__Wextra="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic -Werror % -Wextra"     "-pedantic % -Wextra %% no, obsolete"     #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_gcc_option__Wextra=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_gcc_option__Wextra" >&5
+echo "${ECHO_T}$ac_cv_cflags_gcc_option__Wextra" >&6; }
+case ".$ac_cv_cflags_gcc_option__Wextra" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)  ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_gcc_option__Wextra " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_gcc_option__Wextra") >&5
+  (: CFLAGS does contain $ac_cv_cflags_gcc_option__Wextra) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_gcc_option__Wextra\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wextra") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wextra"
+   fi
+ ;;
+esac
+
+{ echo "$as_me:$LINENO: checking CFLAGS for gcc -Wmissing-prototypes" >&5
+echo $ECHO_N "checking CFLAGS for gcc -Wmissing-prototypes... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_gcc_option__Wmissing_prototypes+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_gcc_option__Wmissing_prototypes="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic -Werror % -Wmissing-prototypes"     "-pedantic % -Wmissing-prototypes %% no, obsolete"     #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_gcc_option__Wmissing_prototypes=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_gcc_option__Wmissing_prototypes" >&5
+echo "${ECHO_T}$ac_cv_cflags_gcc_option__Wmissing_prototypes" >&6; }
+case ".$ac_cv_cflags_gcc_option__Wmissing_prototypes" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)  ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_gcc_option__Wmissing_prototypes " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_gcc_option__Wmissing_prototypes") >&5
+  (: CFLAGS does contain $ac_cv_cflags_gcc_option__Wmissing_prototypes) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_gcc_option__Wmissing_prototypes\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wmissing_prototypes") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wmissing_prototypes"
+   fi
+ ;;
+esac
+
+{ echo "$as_me:$LINENO: checking CFLAGS for gcc -Wstrict-prototypes" >&5
+echo $ECHO_N "checking CFLAGS for gcc -Wstrict-prototypes... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_gcc_option__Wstrict_prototypes+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_gcc_option__Wstrict_prototypes="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic -Werror % -Wstrict-prototypes"     "-pedantic % -Wstrict-prototypes %% no, obsolete"     #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_gcc_option__Wstrict_prototypes=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_gcc_option__Wstrict_prototypes" >&5
+echo "${ECHO_T}$ac_cv_cflags_gcc_option__Wstrict_prototypes" >&6; }
+case ".$ac_cv_cflags_gcc_option__Wstrict_prototypes" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)  ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_gcc_option__Wstrict_prototypes " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_gcc_option__Wstrict_prototypes") >&5
+  (: CFLAGS does contain $ac_cv_cflags_gcc_option__Wstrict_prototypes) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_gcc_option__Wstrict_prototypes\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wstrict_prototypes") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wstrict_prototypes"
+   fi
+ ;;
+esac
+
+{ echo "$as_me:$LINENO: checking CFLAGS for gcc -Wwrite-strings" >&5
+echo $ECHO_N "checking CFLAGS for gcc -Wwrite-strings... $ECHO_C" >&6; }
+if test "${ac_cv_cflags_gcc_option__Wwrite_strings+set}" = set; then
+  echo $ECHO_N "(cached) $ECHO_C" >&6
+else
+  ac_cv_cflags_gcc_option__Wwrite_strings="no, unknown"
+
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+ ac_save_CFLAGS="$CFLAGS"
+for ac_arg in "-pedantic -Werror % -Wwrite-strings"     "-pedantic % -Wwrite-strings %% no, obsolete"     #
+do CFLAGS="$ac_save_CFLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   cat >conftest.$ac_ext <<_ACEOF
+/* confdefs.h.  */
+_ACEOF
+cat confdefs.h >>conftest.$ac_ext
+cat >>conftest.$ac_ext <<_ACEOF
+/* end confdefs.h.  */
+
+int
+main ()
+{
+return 0;
+  ;
+  return 0;
+}
+_ACEOF
+rm -f conftest.$ac_objext
+if { (ac_try="$ac_compile"
+case "(($ac_try" in
+  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
+  *) ac_try_echo=$ac_try;;
+esac
+eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
+  (eval "$ac_compile") 2>conftest.er1
+  ac_status=$?
+  grep -v '^ *+' conftest.er1 >conftest.err
+  rm -f conftest.er1
+  cat conftest.err >&5
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); } && {
+	 test -z "$ac_c_werror_flag" ||
+	 test ! -s conftest.err
+       } && test -s conftest.$ac_objext; then
+  ac_cv_cflags_gcc_option__Wwrite_strings=`echo $ac_arg | sed -e 's,.*% *,,'` ; break
+else
+  echo "$as_me: failed program was:" >&5
+sed 's/^/| /' conftest.$ac_ext >&5
+
+
+fi
+
+rm -f core conftest.err conftest.$ac_objext conftest.$ac_ext
+done
+ CFLAGS="$ac_save_CFLAGS"
+ ac_ext=c
+ac_cpp='$CPP $CPPFLAGS'
+ac_compile='$CC -c $CFLAGS $CPPFLAGS conftest.$ac_ext >&5'
+ac_link='$CC -o conftest$ac_exeext $CFLAGS $CPPFLAGS $LDFLAGS conftest.$ac_ext $LIBS >&5'
+ac_compiler_gnu=$ac_cv_c_compiler_gnu
+
+
+fi
+{ echo "$as_me:$LINENO: result: $ac_cv_cflags_gcc_option__Wwrite_strings" >&5
+echo "${ECHO_T}$ac_cv_cflags_gcc_option__Wwrite_strings" >&6; }
+case ".$ac_cv_cflags_gcc_option__Wwrite_strings" in
+     .ok|.ok,*)  ;;
+   .|.no|.no,*)  ;;
+   *)
+   if echo " $CFLAGS " | grep " $ac_cv_cflags_gcc_option__Wwrite_strings " 2>&1 >/dev/null
+   then { (echo "$as_me:$LINENO: : CFLAGS does contain \$ac_cv_cflags_gcc_option__Wwrite_strings") >&5
+  (: CFLAGS does contain $ac_cv_cflags_gcc_option__Wwrite_strings) 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+   else { (echo "$as_me:$LINENO: : CFLAGS=\"\$CFLAGS \$ac_cv_cflags_gcc_option__Wwrite_strings\"") >&5
+  (: CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wwrite_strings") 2>&5
+  ac_status=$?
+  echo "$as_me:$LINENO: \$? = $ac_status" >&5
+  (exit $ac_status); }
+                      CFLAGS="$CFLAGS $ac_cv_cflags_gcc_option__Wwrite_strings"
+   fi
+ ;;
+esac
+
+
 # Extract the first word of "flawfinder", so it can be a program name with args.
 set dummy flawfinder; ac_word=$2
 { echo "$as_me:$LINENO: checking for $ac_word" >&5
@@ -12303,11 +12927,6 @@
 
 
 
-if test "$GCC" = yes; then
-  fastjar_warn_cflags='-W -Wall -pedantic -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings'
-fi
-
-
 
 
 
@@ -21427,7 +22046,7 @@
 # report actual input values of CONFIG_FILES etc. instead of their
 # values after options handling.
 ac_log="
-This file was extended by fastjar $as_me 0.96, which was
+This file was extended by fastjar $as_me 0.97, which was
 generated by GNU Autoconf 2.61.  Invocation command line was
 
   CONFIG_FILES    = $CONFIG_FILES
@@ -21480,7 +22099,7 @@
 _ACEOF
 cat >>$CONFIG_STATUS <<_ACEOF
 ac_cs_version="\\
-fastjar config.status 0.96
+fastjar config.status 0.97
 configured by $0, generated by GNU Autoconf 2.61,
   with options \\"`echo "$ac_configure_args" | sed 's/^ //; s/[\\""\`\$]/\\\\&/g'`\\"
 
@@ -22071,7 +22690,6 @@
 PSCAN!$PSCAN$ac_delim
 RATS!$RATS$ac_delim
 SPLINT!$SPLINT$ac_delim
-fastjar_warn_cflags!$fastjar_warn_cflags$ac_delim
 ZLIBS!$ZLIBS$ac_delim
 GL_COND_LIBTOOL_TRUE!$GL_COND_LIBTOOL_TRUE$ac_delim
 GL_COND_LIBTOOL_FALSE!$GL_COND_LIBTOOL_FALSE$ac_delim
@@ -22152,6 +22770,7 @@
 REPLACE_FTELLO!$REPLACE_FTELLO$ac_delim
 REPLACE_FTELL!$REPLACE_FTELL$ac_delim
 REPLACE_FFLUSH!$REPLACE_FFLUSH$ac_delim
+HAVE_DECL_GETDELIM!$HAVE_DECL_GETDELIM$ac_delim
 _ACEOF
 
   if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 97; then
@@ -22193,7 +22812,6 @@
 ac_delim='%!_!# '
 for ac_last_try in false false false false false :; do
   cat >conf$$subs.sed <<_ACEOF
-HAVE_DECL_GETDELIM!$HAVE_DECL_GETDELIM$ac_delim
 HAVE_DECL_GETLINE!$HAVE_DECL_GETLINE$ac_delim
 REPLACE_GETLINE!$REPLACE_GETLINE$ac_delim
 HAVE_DECL_OBSTACK_PRINTF!$HAVE_DECL_OBSTACK_PRINTF$ac_delim
@@ -22290,6 +22908,7 @@
 GNULIB_LSEEK!$GNULIB_LSEEK$ac_delim
 GNULIB_READLINK!$GNULIB_READLINK$ac_delim
 GNULIB_SLEEP!$GNULIB_SLEEP$ac_delim
+HAVE_DUP2!$HAVE_DUP2$ac_delim
 _ACEOF
 
   if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 97; then
@@ -22331,7 +22950,6 @@
 ac_delim='%!_!# '
 for ac_last_try in false false false false false :; do
   cat >conf$$subs.sed <<_ACEOF
-HAVE_DUP2!$HAVE_DUP2$ac_delim
 HAVE_FTRUNCATE!$HAVE_FTRUNCATE$ac_delim
 HAVE_GETPAGESIZE!$HAVE_GETPAGESIZE$ac_delim
 HAVE_READLINK!$HAVE_READLINK$ac_delim
@@ -22368,7 +22986,7 @@
 gltests_LTLIBOBJS!$gltests_LTLIBOBJS$ac_delim
 _ACEOF
 
-  if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 35; then
+  if test `sed -n "s/.*$ac_delim\$/X/p" conf$$subs.sed | grep -c X` = 34; then
     break
   elif $ac_last_try; then
     { { echo "$as_me:$LINENO: error: could not make $CONFIG_STATUS" >&5

=== modified file 'configure.ac'
--- configure.ac	2008-08-14 21:24:49 +0000
+++ configure.ac	2008-11-11 05:58:19 +0000
@@ -1,6 +1,6 @@
 dnl Process this file with autoconf to produce a configure script.
 AC_PREREQ(2.61)
-AC_INIT([fastjar],[0.96]) 
+AC_INIT([fastjar],[0.97]) 
 AC_CONFIG_SRCDIR([jartool.h])
 AM_INIT_AUTOMAKE([-Wall gnu 1.10])
 AC_CONFIG_HEADERS([config.h])
@@ -20,17 +20,19 @@
 
 AM_MAINTAINER_MODE
 
+AX_CFLAGS_WARN_ALL
+AX_CFLAGS_GCC_OPTION([-pedantic])
+AX_CFLAGS_GCC_OPTION([-W])
+AX_CFLAGS_GCC_OPTION([-Wextra])
+AX_CFLAGS_GCC_OPTION([-Wmissing-prototypes])
+AX_CFLAGS_GCC_OPTION([-Wstrict-prototypes])
+AX_CFLAGS_GCC_OPTION([-Wwrite-strings])
+
 AC_PATH_PROG([FLAWFINDER],[flawfinder])
 AC_PATH_PROG([PSCAN],[pscan])
 AC_PATH_PROG([RATS],[rats])
 AC_PATH_PROG([SPLINT],[splint])
 
-dnl Add warning flags if we are using gcc.
-if test "$GCC" = yes; then
-  fastjar_warn_cflags='-W -Wall -pedantic -Wstrict-prototypes -Wmissing-prototypes -Wwrite-strings'
-fi
-AC_SUBST(fastjar_warn_cflags)
-
 dnl Checks for header files.
 AC_HEADER_DIRENT
 AC_HEADER_STDC

=== modified file 'fastjar.1'
--- fastjar.1	2008-08-14 21:24:49 +0000
+++ fastjar.1	2008-11-11 05:58:19 +0000
@@ -132,7 +132,7 @@
 .\" ========================================================================
 .\"
 .IX Title "FASTJAR 1"
-.TH FASTJAR 1 "2008-08-06" "0.96" "GNU"
+.TH FASTJAR 1 "2008-10-16" "0.97" "GNU"
 .\" For nroff, turn off justification.  Always turn off hyphenation; it makes
 .\" way too many mistakes in technical documents.
 .if n .ad l

=== modified file 'fastjar.texi'
--- fastjar.texi	2008-08-14 21:24:49 +0000
+++ fastjar.texi	2008-11-11 05:58:19 +0000
@@ -10,7 +10,7 @@
 @c When this manual is copyrighted.
 @set copyrights-fastjar 2002, 2007, 2008
 
-@set version 0.96
+@set version 0.97
 
 @c Common macros to support generating man pages:
 

=== modified file 'grepjar.1'
--- grepjar.1	2008-08-14 21:24:49 +0000
+++ grepjar.1	2008-11-11 05:58:19 +0000
@@ -132,7 +132,7 @@
 .\" ========================================================================
 .\"
 .IX Title "GREPJAR 1"
-.TH GREPJAR 1 "2008-08-06" "0.96" "GNU"
+.TH GREPJAR 1 "2008-10-16" "0.97" "GNU"
 .\" For nroff, turn off justification.  Always turn off hyphenation; it makes
 .\" way too many mistakes in technical documents.
 .if n .ad l

=== modified file 'jargrep.c'
--- jargrep.c	2008-08-14 21:24:49 +0000
+++ jargrep.c	2008-11-11 05:58:19 +0000
@@ -27,14 +27,18 @@
 #include "config.h"
 #endif
 
+#include <ctype.h>
+#include <errno.h>
+#include <fcntl.h>
+#include <inttypes.h>
 #include <stdio.h>
-#include <unistd.h>
-#include <errno.h>
+#include <stdint.h>
 #include <string.h>
 #include <sys/types.h>
 #include <sys/stat.h>
-#include <fcntl.h>
-#include <ctype.h>
+#ifdef HAVE_UNISTD_H
+#include <unistd.h>
+#endif
 #ifdef HAVE_STDLIB_H
 #include <stdlib.h>
 #endif
@@ -132,7 +136,7 @@
 do some more reading.
 */
 static int check_sig(ub1 *scratch, pb_file *pbfp) {
-	ub4 signature;
+	uint32_t signature;
 	int retflag = 0;
 
 	signature = UNPACK_UB4(scratch, 0);
@@ -152,7 +156,7 @@
 #endif
       retflag = 1;
     }else if(signature != 0x04034b50){
-      printf("Ick! %#x\n", signature);
+      printf("Ick! %#" PRIx32 "\n", signature);
       retflag = 1;
     }
     
@@ -386,8 +390,8 @@
 */
 
 static void check_crc(pb_file *pbf, const char *stream, ub4 usize) {
-	ub4 crc=0;
-	ub4 lcrc;
+	uint32_t crc=0;
+	uint32_t lcrc;
 	ub1 scratch[16];
 
 	crc = crc32(crc, NULL, 0);
@@ -402,8 +406,9 @@
 	}
 	lcrc = UNPACK_UB4(scratch, 4);
 	if(crc != lcrc){
-    	fprintf(stderr, "Error! CRCs do not match! Got %x, expected %x\n",
-              crc, lcrc);
+    	fprintf(stderr, "Error! CRCs do not match! Got %" PRIx32 
+                        ", expected %" PRIx32 "\n",
+                crc, lcrc);
       	exit(EXIT_FAILURE);
     }
 }

=== modified file 'jartool.c'
--- jartool.c	2008-08-14 21:24:49 +0000
+++ jartool.c	2008-11-11 05:58:19 +0000
@@ -23,6 +23,9 @@
 #include "config.h"
 #endif
 
+#include <inttypes.h>
+#include <stdint.h>
+
 #include <zlib.h>
 
 #ifdef HAVE_STDLIB_H
@@ -102,6 +105,7 @@
 
 typedef struct ziplistentry ziplistentry;
 
+static void exit_on_error(const char* message);
 static void usage(const char*);
 static void help(const char *);
 static void version(void);
@@ -354,8 +358,7 @@
       if ((jarfd = open (jarfile, O_RDWR | O_BINARY)) < 0)
 	{
 	  fprintf (stderr, "Error opening %s for reading!\n", jarfile);
-	  perror (jarfile);
-	  exit(EXIT_FAILURE);
+	  exit_on_error (jarfile);
 	}
 
       /* Assert that jarfd is seekable. */
@@ -425,7 +428,8 @@
     /* Check if the file shrunk when we updated it. */
     if (action == ACTION_UPDATE)
 #ifdef HAVE_FTRUNCATE
-      ftruncate (jarfd, lseek (jarfd, 0, SEEK_CUR));
+      if (-1 == ftruncate (jarfd, lseek (jarfd, 0, SEEK_CUR)))
+	exit_on_error("ftruncate");
 #else
       _chsize (jarfd, lseek (jarfd, 0, SEEK_CUR));
 #endif
@@ -462,7 +466,8 @@
     create_central_header(jarfd);
 
 #ifdef HAVE_FTRUNCATE
-    ftruncate (jarfd, lseek (jarfd, 0, SEEK_CUR));
+    if (-1 == ftruncate (jarfd, lseek (jarfd, 0, SEEK_CUR)))
+      exit_on_error("ftruncate");
 #else
     _chsize (jarfd, lseek (jarfd, 0, SEEK_CUR));
 #endif
@@ -478,6 +483,13 @@
   exit(EXIT_SUCCESS);
 }
 
+static void
+exit_on_error(const char* message)
+{
+  perror(message);
+  exit(EXIT_FAILURE);
+}
+
 static int args_current_g;
 static const char **args_g;
 
@@ -521,10 +533,7 @@
 
       s = (char *) malloc (len);
       if (s == NULL)
-	{
-	  perror ("malloc");
-	  exit(EXIT_FAILURE);
-	}
+	exit_on_error("malloc");
 
       /* Get rid of '\n' and '\r' first. */
       while (1)
@@ -555,10 +564,7 @@
 	      len *= 2;
 	      s = (char *) realloc (s, len);
 	      if (s == NULL)
-		{
-		  perror ("realloc");
-		  exit(EXIT_FAILURE);
-		}
+		  exit_on_error ("realloc");
 	    }
 	}
 
@@ -672,6 +678,7 @@
 /*
  * Read the zip entries of an existing file, building `ziplist' as we go.
  */
+static
 int read_entries (int fd)
 {
   struct zipentry *ze;
@@ -812,49 +819,48 @@
   size_t nlen;   /* length of file name */
   int mod_time; /* file modification time */
   struct zipentry *ze;
-  
-  nlen = 9;  /* trust me on this one */
-
-  memset((file_header + 12), '\0', 16); /*clear mod time, crc, size fields*/
-  
-  current_time = time(NULL);
-  if(current_time == (time_t)-1){
-    perror("time");
-    exit(EXIT_FAILURE);
-  }
-
-  mod_time = unix2dostime(&current_time);
-  
-  PACK_UB2(file_header, LOC_EXTRA, 0);
-  PACK_UB2(file_header, LOC_COMP, 0);
-  PACK_UB2(file_header, LOC_FNLEN, nlen);
-  PACK_UB4(file_header, LOC_MODTIME, mod_time);
-  
-  if(verbose)
-    printf("adding: META-INF/ (in=0) (out=0) (stored 0%%)\n");
-  
-  ze = (zipentry*)malloc(sizeof(zipentry));
-  if(ze == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  
-  memset(ze, 0, sizeof(zipentry)); /* clear all the fields*/
-  ze->filename = strdup("META-INF/");
-  if (NULL == ze->filename) {
-     perror("strdup");
-     exit(EXIT_FAILURE);
-  }
-
-  ze->offset = lseek(jfd, 0, SEEK_CUR);
-  ze->mod_time = (ub2)(mod_time & 0x0000ffff);
-  ze->mod_date = (ub2)((mod_time & 0xffff0000) >> 16);
-  ze->compressed = FALSE;
-
-  add_entry(ze);
-  
-  write(jfd, file_header, 30);
-  write(jfd, "META-INF/", nlen);
+
+  mod_time = unix2dostime(&current_time);  
+  
+  /* If we are creating a new manifest, create a META-INF directory entry */
+  if (0 == updating) {
+    nlen = 9;  /* trust me on this one */
+
+    memset((file_header + 12), '\0', 16); /*clear mod time, crc, size fields*/
+  
+    current_time = time(NULL);
+    if(current_time == (time_t)-1)
+      exit_on_error("time");
+
+    PACK_UB2(file_header, LOC_EXTRA, 0);
+    PACK_UB2(file_header, LOC_COMP, 0);
+    PACK_UB2(file_header, LOC_FNLEN, nlen);
+    PACK_UB4(file_header, LOC_MODTIME, mod_time);
+  
+    if(verbose)
+      printf("adding: META-INF/ (in=0) (out=0) (stored 0%%)\n");
+  
+    ze = (zipentry*)malloc(sizeof(zipentry));
+    if(ze == NULL)
+      exit_on_error("malloc");
+  
+    memset(ze, 0, sizeof(zipentry)); /* clear all the fields*/
+    ze->filename = strdup("META-INF/");
+    if (NULL == ze->filename)
+      exit_on_error("strdup");
+
+    ze->offset = lseek(jfd, 0, SEEK_CUR);
+    ze->mod_time = (ub2)(mod_time & 0x0000ffff);
+    ze->mod_date = (ub2)((mod_time & 0xffff0000) >> 16);
+    ze->compressed = FALSE;
+
+    add_entry(ze);
+
+    if (-1 == write(jfd, file_header, 30))
+      exit_on_error("write");
+    if (-1 == write(jfd, "META-INF/", nlen))
+      exit_on_error("write");
+  }
 
   /* if the user didn't specify an external manifest file... */
   if(mf_name == NULL){
@@ -886,17 +892,13 @@
       printf("adding: META-INF/MANIFEST.MF (in=56) (out=56) (stored 0%%)\n");
     
     ze = (zipentry*)malloc(sizeof(zipentry));
-    if(ze == NULL){
-      perror("malloc");
-      exit(EXIT_FAILURE);
-    }
+    if(ze == NULL)
+      exit_on_error("malloc");
     
     memset(ze, 0, sizeof(zipentry)); /* clear all the fields*/
     ze->filename = strdup("META-INF/MANIFEST.MF");
-    if (NULL == ze->filename) {
-      perror("strdup");
-      exit(EXIT_FAILURE);
-    }
+    if (NULL == ze->filename)
+      exit_on_error("strdup");
     
     ze->offset = lseek(jfd, 0, SEEK_CUR);
     ze->mod_time = (ub2)(mod_time & 0x0000ffff);
@@ -908,9 +910,12 @@
     
     add_entry(ze);
     
-    write(jfd, file_header, 30);
-    write(jfd, "META-INF/MANIFEST.MF", nlen);
-    write(jfd, mf, mf_len);
+    if (-1 == write(jfd, file_header, 30))
+      exit_on_error("write");
+    if (-1 == write(jfd, "META-INF/MANIFEST.MF", nlen))
+      exit_on_error("write");
+    if (-1 == write(jfd, mf, mf_len))
+      exit_on_error("write");
     free(mf);
     }
     else {
@@ -935,11 +940,8 @@
       exit(EXIT_FAILURE);
     }
 
-    if(add_file_to_jar(jfd, mfd, "META-INF/MANIFEST.MF", &statbuf, updating)){
-      perror("error writing to jar");
-      exit(EXIT_FAILURE);
-    }
-
+    if(add_file_to_jar(jfd, mfd, "META-INF/MANIFEST.MF", &statbuf, updating))
+      exit_on_error("error writing to jar");
   }
 
   return 0;
@@ -963,10 +965,7 @@
   
   old_dir = (char *) malloc (old_dir_len);
   if (old_dir == NULL)
-    {
-      perror ("malloc");
-      exit(EXIT_FAILURE);
-    }
+      exit_on_error ("malloc");
 
   while (1)
     {
@@ -980,10 +979,7 @@
       old_dir_len *= 2;
       old_dir = (char *) realloc (old_dir, old_dir_len); 
       if (old_dir == NULL)
-	{
-	  perror ("realloc");
-	  exit(EXIT_FAILURE);
-	}
+	  exit_on_error ("realloc");
     }
 
   if (chdir(new_dir) == -1) {
@@ -1074,10 +1070,8 @@
     PACK_UB4(file_header, LOC_MODTIME, mod_time);
 
     ze = (zipentry*)malloc(sizeof(zipentry));
-    if(ze == NULL){
-      perror("malloc");
-      exit(EXIT_FAILURE);
-    }
+    if(ze == NULL)
+      exit_on_error("malloc");
 
     memset(ze, 0, sizeof(zipentry)); /* clear all the fields*/
     ze->filename = strdup(fullname);
@@ -1110,8 +1104,10 @@
     if (!existing)
       {
 	add_entry (ze);
-	write (fd, file_header, 30);
-	write (fd, fullname, nlen);
+	if (-1 == write (fd, file_header, 30))
+	  exit_on_error("write");
+	if (-1 == write (fd, fullname, nlen))
+	  exit_on_error("write");
 	end_of_entries = lseek (fd, 0, SEEK_CUR);
 
 	if (verbose)
@@ -1218,11 +1214,9 @@
     memset((file_header + LOC_CRC), '\0', 12); /* clear crc/usize/csize */
   
   ze = (zipentry*)malloc(sizeof(zipentry));
-  if(ze == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
-  
+  if(ze == NULL)
+    exit_on_error("malloc");
+
   memset(ze, 0, sizeof(zipentry)); /* clear all the fields*/
   ze->filename = strdup(fname);
 
@@ -1259,11 +1253,12 @@
      as before */
   
   /* Write the local header */
-  write(jfd, file_header, 30);
-    
+  if (-1 == write(jfd, file_header, 30))
+      exit_on_error("write");
+
   /* write the file name to the zip file */
-  write(jfd, fname, file_name_length);
-
+  if (1 == write(jfd, fname, file_name_length))
+    exit_on_error("write");
 
   if(verbose){
     if (existing)
@@ -1314,10 +1309,8 @@
   if(seekable){
     offset = (ze->csize + strlen(ze->filename) + 16);
     
-    if(lseek(jfd, -offset, SEEK_CUR) == (off_t)-1){
-      perror("lseek");
-      exit(EXIT_FAILURE);
-    }
+    if(lseek(jfd, -offset, SEEK_CUR) == (off_t)-1)
+      exit_on_error("lseek");
 
     if(write(jfd, (data_descriptor + 4), 12) != 12){
       perror("write");
@@ -1326,10 +1319,9 @@
     
     offset -= 12;
 
-    if(lseek(jfd, offset, SEEK_CUR) == (off_t)-1){
-      perror("lseek");
-      exit(EXIT_FAILURE);
-    }
+    if(lseek(jfd, offset, SEEK_CUR) == (off_t)-1)
+      exit_on_error("lseek");
+
   } else if(do_compress){
     /* Sun's jar tool will only allow a data descriptor if the entry is
        compressed, but we'll save 16 bytes/entry if we only use it when
@@ -1474,9 +1466,11 @@
     PACK_UB2(header, CEN_FNLEN, strlen(ze->filename));
     PACK_UB4(header, CEN_OFFSET, ze->offset);
 
-    write(fd, header, 46);
+    if (-1 == write(fd, header, 46))
+      exit_on_error("write");
 
-    write(fd, ze->filename, strlen(ze->filename));
+    if (-1 == write(fd, ze->filename, strlen(ze->filename)))
+      exit_on_error("write");
   }
 
   dir_size = lseek(fd, 0, SEEK_CUR) - start_offset;
@@ -1504,8 +1498,9 @@
   end_header[20] = 0;
   end_header[21] = 0;
 
-  write(fd, end_header, 22);
-  
+  if (-1 == write(fd, end_header, 22))
+    exit_on_error("write");
+
   if(verbose)
     printf("Total:\n------\n(in = %d) (out = %d) (%s %d%%)\n", 
            total_in, 
@@ -1520,7 +1515,7 @@
 int extract_jar(int fd, const char **files, int file_num){
   size_t rdamt;
   int out_a, in_a;
-  ub4 signature;
+  uint32_t signature;
   ub4 csize;
   ub4 crc;
   ub2 fnlen;
@@ -1580,7 +1575,7 @@
 #endif
       break;
     }else if(signature != 0x04034b50){
-      printf("Ick! %#x\n", signature);
+      printf("Ick! %#" PRIx32 "\n", signature);
       break;
     }
     
@@ -1698,7 +1693,7 @@
             /* Add 10 more spots to subdir_list */
             if (subdir_list_index == subdir_list_size) {
               subdir_list_size = subdir_list_size + 10;
-              subdir_list = realloc(subdir_list, (subdir_list_size) * sizeof(char));
+              subdir_list = realloc(subdir_list, (subdir_list_size) * sizeof(char *));
 
               if (subdir_list == NULL) {
                 fprintf(stderr, "error realloc-ing subdir_list_size\n");
@@ -1763,10 +1758,8 @@
 	} else if (strcmp(tmp_buff, ".") != 0)
 	  ++depth;
         if(stat(tmp_buff, &sbuf) < 0){
-          if(errno != ENOENT){
-            perror("stat");
-            exit(EXIT_FAILURE);
-          }
+          if(errno != ENOENT)
+            exit_on_error("stat");
 
         } else if(S_ISDIR(sbuf.st_mode)){
 #ifdef DEBUG    
@@ -1782,10 +1775,9 @@
 #ifdef DEBUG    
         printf("Making directory..\n");
 #endif
-        if(mkdir(tmp_buff, 0755) < 0){
-          perror("mkdir");
-          exit(EXIT_FAILURE);
-        }
+        if(mkdir(tmp_buff, 0755) < 0)
+          exit_on_error("mkdir");
+
         if(verbose && handle)
           printf("%10s: %s/\n", "created", tmp_buff);
 
@@ -1812,8 +1804,7 @@
 
       if(f_fd < 0){
         fprintf(stderr, "Error extracting JAR archive!\n");
-        perror((const char *)filename);
-        exit(EXIT_FAILURE);
+        exit_on_error((const char *)filename);
       }
     }
 
@@ -1841,20 +1832,16 @@
 
       while(out_a < (int)csize){
         rdamt = (in_a > RDSZ ? RDSZ : in_a);
-        if(pb_read(&pbf, rd_buff, rdamt) != rdamt){
-          perror("read");
-          exit(EXIT_FAILURE);
-        }
+        if(pb_read(&pbf, rd_buff, rdamt) != rdamt)
+          exit_on_error("read");
         
         ze.crc = crc32(ze.crc, (Bytef*)rd_buff, rdamt);
 
         if(f_fd >= 0) {
 	  ssize_t num_written;
           num_written = write(f_fd, rd_buff, rdamt);
-	  if (num_written == -1) {
-	    perror("write");
-	    exit(EXIT_FAILURE);
-	  }
+	  if (num_written == -1)
+	    exit_on_error("write");
 	}
 
         out_a += rdamt;
@@ -1869,10 +1856,8 @@
     /* if there is a data descriptor left, compare the CRC */
     if(flags & 0x0008){
 
-      if(pb_read(&pbf, scratch, 16) != 16){
-        perror("read");
-        exit(EXIT_FAILURE);
-      }
+      if(pb_read(&pbf, scratch, 16) != 16)
+        exit_on_error("read");
 
       signature = UNPACK_UB4(scratch, 0);
 
@@ -1902,6 +1887,7 @@
   for (j = 0; j < subdir_list_index; j++) {
     free(subdir_list[j]);
   }
+  free(subdir_list); 
   return 0;
 }
 
@@ -1936,15 +1922,11 @@
 
   /* This should be the start of the central-header-end section */
   if(seekable){
-    if(lseek(fd, -22, SEEK_END) == (off_t)-1){
-      perror("lseek");
-      exit(EXIT_FAILURE);
-    }
+    if(lseek(fd, -22, SEEK_END) == (off_t)-1)
+      exit_on_error("lseek");
     
-    if(read(fd, &tmp, sizeof(ub4)) != 4){
-      perror("read");
-      exit(EXIT_FAILURE);
-    }
+    if(read(fd, &tmp, sizeof(ub4)) != 4)
+      exit_on_error("read");
 
 #ifdef WORDS_BIGENDIAN
     tmp = L2BI(tmp);
@@ -1958,20 +1940,14 @@
          position, so we have to fall back on the method used for
          non-seekable files. */
       seekable = FALSE;
-      if(lseek(fd, 0, SEEK_SET) == (off_t)-1){
-        perror("lseek");
-        exit(EXIT_FAILURE);
-      }
+      if(lseek(fd, 0, SEEK_SET) == (off_t)-1)
+        exit_on_error("lseek");
     } else {
-      if(lseek(fd, 6, SEEK_CUR) == (off_t)-1){
-        perror("lseek");
-        exit(EXIT_FAILURE);
-      }
+      if(lseek(fd, 6, SEEK_CUR) == (off_t)-1)
+        exit_on_error("lseek");
   
-      if(read(fd, &cen_size, 2) != 2){
-        perror("read");
-        exit(EXIT_FAILURE);
-      }
+      if(read(fd, &cen_size, 2) != 2)
+        exit_on_error("read");
 
 #ifdef WORDS_BIGENDIAN
       cen_size = L2BS(cen_size);
@@ -1979,15 +1955,12 @@
 
       /*   printf("%hu entries in central header\n", cen_size); */
 
-      if(lseek(fd, 4, SEEK_CUR) == (off_t)-1){
-        perror("lseek");
-        exit(EXIT_FAILURE);
-      }
-
-      if(read(fd, &tmp, 4) != 4){
-        perror("read");
-        exit(EXIT_FAILURE);
-      }
+      if(lseek(fd, 4, SEEK_CUR) == (off_t)-1)
+        exit_on_error("lseek");
+
+      if(read(fd, &tmp, 4) != 4)
+        exit_on_error("read");
+
 
 #ifdef WORDS_BIGENDIAN
       tmp = L2BI(tmp);
@@ -1997,10 +1970,8 @@
 
       /*   printf("Central header offset = %d\n", central_header_offset); */
 
-      if(lseek(fd, central_header_offset, SEEK_SET) != central_header_offset){
-        perror("lseek");
-        exit(EXIT_FAILURE);
-      }
+      if(lseek(fd, central_header_offset, SEEK_SET) != central_header_offset)
+        exit_on_error("lseek");
 
       /* Loop through the entries in the central header */
       for(i = 0; i < cen_size; i++){
@@ -2008,10 +1979,8 @@
 
         read_amt = read(fd, &cen_header, 46);
     
-        if(read_amt == -1 || read_amt != 46){
-          perror("read");
-          exit(EXIT_FAILURE);
-        }
+        if(read_amt == -1 || read_amt != 46)
+          exit_on_error("read");
 
         signature = UNPACK_UB4(cen_header, 0);
         if(signature != 0x02014b50){
@@ -2033,10 +2002,9 @@
           tdate = dos2unixtime(mdate);
           s_tm = localtime(&tdate);
           time_string_length = strftime(ascii_date, 30, "%a %b %d %H:%M:%S %Z %Y", s_tm);
-	  if (0 == time_string_length) {
-	    perror("strftime");
-	    exit(EXIT_FAILURE);
-	  }
+	  if (0 == time_string_length)
+	    exit_on_error("strftime");
+
           ascii_date[30] = '\0';
         }
 
@@ -2045,18 +2013,16 @@
             free(filename);
 
           filename = malloc(sizeof(ub1) * (fnlen + 1));
-          if (NULL == filename) {
-            perror("malloc");
-            exit(EXIT_FAILURE);
-          }
+          if (NULL == filename)
+            exit_on_error("malloc");
+
           filename_len = fnlen + 1;
         }
     
         read_amt = read(fd, filename, fnlen);
-        if(read_amt == -1 || read_amt != (ssize_t) fnlen){
-          perror("read");
-          exit(EXIT_FAILURE);
-        }
+        if(read_amt == -1 || read_amt != (ssize_t) fnlen)
+          exit_on_error("read");
+
         filename[fnlen] = (ub1) '\0';
     
         /* if the user specified a list of files on the command line,
@@ -2079,10 +2045,8 @@
       
         size = eflen + clen;
         if(size > 0){
-          if(lseek(fd, size, SEEK_CUR) == (off_t)-1){
-            perror("lseek");
-            exit(EXIT_FAILURE);
-          }
+          if(lseek(fd, size, SEEK_CUR) == (off_t)-1)
+            exit_on_error("lseek");
 	}
       }
     }
@@ -2247,10 +2211,8 @@
 #endif
   
   buff = (ub1 *) malloc(RDSZ * sizeof(ub1));
-  if (NULL == buff) {
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
+  if (NULL == buff)
+    exit_on_error("malloc");
 
   if (seekable){
     if (amt <= pbf->buff_amt)
@@ -2258,10 +2220,9 @@
     else {
       off_t location;
       location = lseek(pbf->fd, amt - pbf->buff_amt, SEEK_CUR);
-      if (location == -1) {
-        perror("lseek");
-        exit(EXIT_FAILURE);
-      }
+      if (location == -1)
+        exit_on_error("lseek");
+
       tc += pb_read(pbf, buff, pbf->buff_amt); /* clear pbf */
     }
   } else
@@ -2464,10 +2425,8 @@
     }
 
   current_time = time(NULL);
-  if(current_time == (time_t)-1){
-    perror("time");
-    exit(EXIT_FAILURE);
-  }
+  if(current_time == (time_t)-1)
+    exit_on_error("time");
 
   mod_time = unix2dostime(&current_time);
   file_name_length = strlen(fname);
@@ -2495,10 +2454,8 @@
       memset((file_header + LOC_CRC), '\0', 12);  /* clear crc/usize/csize */
   
   ze = (zipentry*)malloc(sizeof(zipentry));
-  if(ze == NULL){
-    perror("malloc");
-    exit(EXIT_FAILURE);
-  }
+  if(ze == NULL)
+    exit_on_error("malloc");
   
   memset(ze, 0, sizeof(zipentry)); /* clear all the fields*/
   ze->filename = strdup(fname);
@@ -2534,18 +2491,13 @@
   
   /* Write the local header */
   written = write(jfd, file_header, 30);
-  if ((written == -1) || ((size_t) written != 30)){
-    perror("write");
-    exit(EXIT_FAILURE);
-  }
+  if ((written == -1) || ((size_t) written != 30))
+    exit_on_error("write");
 
   /* write the file name to the zip file */
   written = write(jfd, fname, file_name_length);
-  if ((written == -1) || ((size_t) written != file_name_length)){
-    perror("write");
-    exit(EXIT_FAILURE);
-  }
-
+  if ((written == -1) || ((size_t) written != file_name_length))
+    exit_on_error("write");
 
   if(verbose){
     if (existing)
@@ -2576,10 +2528,8 @@
       
   ze->crc = crc32(ze->crc, (unsigned char*)content, content_length);
   written = write(jfd, content, content_length);
-  if ((written == -1) || ((size_t) written != content_length)){
-    perror("write");
-    exit(EXIT_FAILURE);
-  }
+  if ((written == -1) || ((size_t) written != content_length))
+    exit_on_error("write");
       
   /* write out data descriptor */
   PACK_UB4(data_descriptor, 4, ze->crc);
@@ -2590,10 +2540,8 @@
   if(seekable){
     offset = (ze->csize + strlen(ze->filename) + 16);
     
-    if(lseek(jfd, -offset, SEEK_CUR) == (off_t)-1){
-      perror("lseek");
-      exit(EXIT_FAILURE);
-    }
+    if(lseek(jfd, -offset, SEEK_CUR) == (off_t)-1)
+      exit_on_error("lseek");
 
     if(write(jfd, (data_descriptor + 4), 12) != 12){
       perror("write");
@@ -2602,10 +2550,8 @@
     
     offset -= 12;
 
-    if(lseek(jfd, offset, SEEK_CUR) == (off_t)-1){
-      perror("lseek");
-      exit(EXIT_FAILURE);
-    }
+    if(lseek(jfd, offset, SEEK_CUR) == (off_t)-1)
+      exit_on_error("lseek");
   } 
   
   if (existing)
@@ -2651,10 +2597,8 @@
     {
       char * result = strdup(fname);
       if (!result)
-	{
-	  perror("strdup");
-	  exit(EXIT_FAILURE);
-	}
+	  exit_on_error("strdup");
+
       *strrchr(result, '/') = '\0';
       return result;
     }

=== modified file 'lib/Makefile.in'
--- lib/Makefile.in	2008-08-14 21:24:49 +0000
+++ lib/Makefile.in	2008-11-11 05:58:19 +0000
@@ -50,6 +50,8 @@
 	$(srcdir)/Makefile.in alloca.c
 ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
 am__aclocal_m4_deps = $(top_srcdir)/m4/alloca.m4 \
+	$(top_srcdir)/m4/ax_cflags_gcc_option.m4 \
+	$(top_srcdir)/m4/ax_cflags_warn_all.m4 \
 	$(top_srcdir)/m4/codeset.m4 $(top_srcdir)/m4/eoverflow.m4 \
 	$(top_srcdir)/m4/extensions.m4 $(top_srcdir)/m4/float_h.m4 \
 	$(top_srcdir)/m4/getopt.m4 $(top_srcdir)/m4/glibc21.m4 \
@@ -396,7 +398,6 @@
 docdir = @docdir@
 dvidir = @dvidir@
 exec_prefix = @exec_prefix@
-fastjar_warn_cflags = @fastjar_warn_cflags@
 gl_LIBOBJS = @gl_LIBOBJS@
 gl_LTLIBOBJS = @gl_LTLIBOBJS@
 gltests_LIBOBJS = @gltests_LIBOBJS@

=== modified file 'ltmain.sh'
--- ltmain.sh	2008-08-14 21:24:49 +0000
+++ ltmain.sh	2008-11-11 05:58:19 +0000
@@ -65,7 +65,7 @@
 #       compiler:		$LTCC
 #       compiler flags:		$LTCFLAGS
 #       linker:		$LD (gnu? $with_gnu_ld)
-#       $progname:		(GNU libtool) 2.2.4 Debian-2.2.4-0ubuntu3
+#       $progname:		(GNU libtool) 2.2.4 Debian-2.2.4-0ubuntu4
 #       automake:		$automake_version
 #       autoconf:		$autoconf_version
 #
@@ -73,7 +73,7 @@
 
 PROGRAM=ltmain.sh
 PACKAGE=libtool
-VERSION="2.2.4 Debian-2.2.4-0ubuntu3"
+VERSION="2.2.4 Debian-2.2.4-0ubuntu4"
 TIMESTAMP=""
 package_revision=1.2976
 

=== added file 'm4/ax_cflags_gcc_option.m4'
--- m4/ax_cflags_gcc_option.m4	1970-01-01 00:00:00 +0000
+++ m4/ax_cflags_gcc_option.m4	2008-11-11 05:58:19 +0000
@@ -0,0 +1,230 @@
+##### http://autoconf-archive.cryp.to/ax_cflags_gcc_option.html
+#
+# SYNOPSIS
+#
+#   AX_CFLAGS_GCC_OPTION (optionflag [,[shellvar][,[A][,[NA]]])
+#
+# DESCRIPTION
+#
+#   AX_CFLAGS_GCC_OPTION(-fvomit-frame) would show a message as like
+#   "checking CFLAGS for gcc -fvomit-frame ... yes" and adds the
+#   optionflag to CFLAGS if it is understood. You can override the
+#   shellvar-default of CFLAGS of course. The order of arguments stems
+#   from the explicit macros like AX_CFLAGS_WARN_ALL.
+#
+#   The cousin AX_CXXFLAGS_GCC_OPTION would check for an option to add
+#   to CXXFLAGS - and it uses the autoconf setup for C++ instead of C
+#   (since it is possible to use different compilers for C and C++).
+#
+#   The macro is a lot simpler than any special AX_CFLAGS_* macro (or
+#   ac_cxx_rtti.m4 macro) but allows to check for arbitrary options.
+#   However, if you use this macro in a few places, it would be great
+#   if you would make up a new function-macro and submit it to the
+#   ac-archive.
+#
+#     - $1 option-to-check-for : required ("-option" as non-value)
+#     - $2 shell-variable-to-add-to : CFLAGS (or CXXFLAGS in the other case)
+#     - $3 action-if-found : add value to shellvariable
+#     - $4 action-if-not-found : nothing
+#
+#   note: in earlier versions, $1-$2 were swapped. We try to detect the
+#   situation and accept a $2=~/-/ as being the old
+#   option-to-check-for.
+#
+#   also: there are other variants that emerged from the original macro
+#   variant which did just test an option to be possibly added.
+#   However, some compilers accept an option silently, or possibly for
+#   just another option that was not intended. Therefore, we have to do
+#   a generic test for a compiler family. For gcc we check "-pedantic"
+#   being accepted which is also understood by compilers who just want
+#   to be compatible with gcc even when not being made from gcc
+#   sources.
+#
+#   see also:
+#
+#         AX_CFLAGS_SUN_OPTION               AX_CFLAGS_HPUX_OPTION
+#         AX_CFLAGS_AIX_OPTION               AX_CFLAGS_IRIX_OPTION
+#
+# LAST MODIFICATION
+#
+#   2006-12-12
+#
+# COPYLEFT
+#
+#   Copyright (c) 2006 Guido U. Draheim <guidod@gmx.de>
+#
+#   This program is free software; you can redistribute it and/or
+#   modify it under the terms of the GNU General Public License as
+#   published by the Free Software Foundation; either version 2 of the
+#   License, or (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+#   General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program; if not, write to the Free Software
+#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+#   02111-1307, USA.
+#
+#   As a special exception, the respective Autoconf Macro's copyright
+#   owner gives unlimited permission to copy, distribute and modify the
+#   configure scripts that are the output of Autoconf when processing
+#   the Macro. You need not follow the terms of the GNU General Public
+#   License when using or distributing such scripts, even though
+#   portions of the text of the Macro appear in them. The GNU General
+#   Public License (GPL) does govern all other use of the material that
+#   constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the
+#   Autoconf Macro released by the Autoconf Macro Archive. When you
+#   make and distribute a modified version of the Autoconf Macro, you
+#   may extend this special exception to the GPL to apply to your
+#   modified version as well.
+
+AC_DEFUN([AX_CFLAGS_GCC_OPTION_OLD], [dnl
+AS_VAR_PUSHDEF([FLAGS],[CFLAGS])dnl
+AS_VAR_PUSHDEF([VAR],[ac_cv_cflags_gcc_option_$2])dnl
+AC_CACHE_CHECK([m4_ifval($1,$1,FLAGS) for gcc m4_ifval($2,$2,-option)],
+VAR,[VAR="no, unknown"
+ AC_LANG_SAVE
+ AC_LANG_C
+ ac_save_[]FLAGS="$[]FLAGS"
+for ac_arg dnl
+in "-pedantic -Werror % m4_ifval($2,$2,-option)"  dnl   GCC
+   "-pedantic % m4_ifval($2,$2,-option) %% no, obsolete"  dnl new GCC
+   #
+do FLAGS="$ac_save_[]FLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   AC_TRY_COMPILE([],[return 0;],
+   [VAR=`echo $ac_arg | sed -e 's,.*% *,,'` ; break])
+done
+ FLAGS="$ac_save_[]FLAGS"
+ AC_LANG_RESTORE
+])
+case ".$VAR" in
+     .ok|.ok,*) m4_ifvaln($3,$3) ;;
+   .|.no|.no,*) m4_ifvaln($4,$4) ;;
+   *) m4_ifvaln($3,$3,[
+   if echo " $[]m4_ifval($1,$1,FLAGS) " | grep " $VAR " 2>&1 >/dev/null
+   then AC_RUN_LOG([: m4_ifval($1,$1,FLAGS) does contain $VAR])
+   else AC_RUN_LOG([: m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"])
+                      m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"
+   fi ]) ;;
+esac
+AS_VAR_POPDEF([VAR])dnl
+AS_VAR_POPDEF([FLAGS])dnl
+])
+
+
+dnl the only difference - the LANG selection... and the default FLAGS
+
+AC_DEFUN([AX_CXXFLAGS_GCC_OPTION_OLD], [dnl
+AS_VAR_PUSHDEF([FLAGS],[CXXFLAGS])dnl
+AS_VAR_PUSHDEF([VAR],[ac_cv_cxxflags_gcc_option_$2])dnl
+AC_CACHE_CHECK([m4_ifval($1,$1,FLAGS) for gcc m4_ifval($2,$2,-option)],
+VAR,[VAR="no, unknown"
+ AC_LANG_SAVE
+ AC_LANG_CPLUSPLUS
+ ac_save_[]FLAGS="$[]FLAGS"
+for ac_arg dnl
+in "-pedantic -Werror % m4_ifval($2,$2,-option)"  dnl   GCC
+   "-pedantic % m4_ifval($2,$2,-option) %% no, obsolete"  dnl new GCC
+   #
+do FLAGS="$ac_save_[]FLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   AC_TRY_COMPILE([],[return 0;],
+   [VAR=`echo $ac_arg | sed -e 's,.*% *,,'` ; break])
+done
+ FLAGS="$ac_save_[]FLAGS"
+ AC_LANG_RESTORE
+])
+case ".$VAR" in
+     .ok|.ok,*) m4_ifvaln($3,$3) ;;
+   .|.no|.no,*) m4_ifvaln($4,$4) ;;
+   *) m4_ifvaln($3,$3,[
+   if echo " $[]m4_ifval($1,$1,FLAGS) " | grep " $VAR " 2>&1 >/dev/null
+   then AC_RUN_LOG([: m4_ifval($1,$1,FLAGS) does contain $VAR])
+   else AC_RUN_LOG([: m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"])
+                      m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"
+   fi ]) ;;
+esac
+AS_VAR_POPDEF([VAR])dnl
+AS_VAR_POPDEF([FLAGS])dnl
+])
+
+dnl -------------------------------------------------------------------------
+
+AC_DEFUN([AX_CFLAGS_GCC_OPTION_NEW], [dnl
+AS_VAR_PUSHDEF([FLAGS],[CFLAGS])dnl
+AS_VAR_PUSHDEF([VAR],[ac_cv_cflags_gcc_option_$1])dnl
+AC_CACHE_CHECK([m4_ifval($2,$2,FLAGS) for gcc m4_ifval($1,$1,-option)],
+VAR,[VAR="no, unknown"
+ AC_LANG_SAVE
+ AC_LANG_C
+ ac_save_[]FLAGS="$[]FLAGS"
+for ac_arg dnl
+in "-pedantic -Werror % m4_ifval($1,$1,-option)"  dnl   GCC
+   "-pedantic % m4_ifval($1,$1,-option) %% no, obsolete"  dnl new GCC
+   #
+do FLAGS="$ac_save_[]FLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   AC_TRY_COMPILE([],[return 0;],
+   [VAR=`echo $ac_arg | sed -e 's,.*% *,,'` ; break])
+done
+ FLAGS="$ac_save_[]FLAGS"
+ AC_LANG_RESTORE
+])
+case ".$VAR" in
+     .ok|.ok,*) m4_ifvaln($3,$3) ;;
+   .|.no|.no,*) m4_ifvaln($4,$4) ;;
+   *) m4_ifvaln($3,$3,[
+   if echo " $[]m4_ifval($2,$2,FLAGS) " | grep " $VAR " 2>&1 >/dev/null
+   then AC_RUN_LOG([: m4_ifval($2,$2,FLAGS) does contain $VAR])
+   else AC_RUN_LOG([: m4_ifval($2,$2,FLAGS)="$m4_ifval($2,$2,FLAGS) $VAR"])
+                      m4_ifval($2,$2,FLAGS)="$m4_ifval($2,$2,FLAGS) $VAR"
+   fi ]) ;;
+esac
+AS_VAR_POPDEF([VAR])dnl
+AS_VAR_POPDEF([FLAGS])dnl
+])
+
+
+dnl the only difference - the LANG selection... and the default FLAGS
+
+AC_DEFUN([AX_CXXFLAGS_GCC_OPTION_NEW], [dnl
+AS_VAR_PUSHDEF([FLAGS],[CXXFLAGS])dnl
+AS_VAR_PUSHDEF([VAR],[ac_cv_cxxflags_gcc_option_$1])dnl
+AC_CACHE_CHECK([m4_ifval($2,$2,FLAGS) for gcc m4_ifval($1,$1,-option)],
+VAR,[VAR="no, unknown"
+ AC_LANG_SAVE
+ AC_LANG_CPLUSPLUS
+ ac_save_[]FLAGS="$[]FLAGS"
+for ac_arg dnl
+in "-pedantic -Werror % m4_ifval($1,$1,-option)"  dnl   GCC
+   "-pedantic % m4_ifval($1,$1,-option) %% no, obsolete"  dnl new GCC
+   #
+do FLAGS="$ac_save_[]FLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   AC_TRY_COMPILE([],[return 0;],
+   [VAR=`echo $ac_arg | sed -e 's,.*% *,,'` ; break])
+done
+ FLAGS="$ac_save_[]FLAGS"
+ AC_LANG_RESTORE
+])
+case ".$VAR" in
+     .ok|.ok,*) m4_ifvaln($3,$3) ;;
+   .|.no|.no,*) m4_ifvaln($4,$4) ;;
+   *) m4_ifvaln($3,$3,[
+   if echo " $[]m4_ifval($2,$2,FLAGS) " | grep " $VAR " 2>&1 >/dev/null
+   then AC_RUN_LOG([: m4_ifval($2,$2,FLAGS) does contain $VAR])
+   else AC_RUN_LOG([: m4_ifval($2,$2,FLAGS)="$m4_ifval($2,$2,FLAGS) $VAR"])
+                      m4_ifval($2,$2,FLAGS)="$m4_ifval($2,$2,FLAGS) $VAR"
+   fi ]) ;;
+esac
+AS_VAR_POPDEF([VAR])dnl
+AS_VAR_POPDEF([FLAGS])dnl
+])
+
+AC_DEFUN([AX_CFLAGS_GCC_OPTION],[ifelse(m4_bregexp([$2],[-]),-1,
+[AX_CFLAGS_GCC_OPTION_NEW($@)],[AX_CFLAGS_GCC_OPTION_OLD($@)])])
+
+AC_DEFUN([AX_CXXFLAGS_GCC_OPTION],[ifelse(m4_bregexp([$2],[-]),-1,
+[AX_CXXFLAGS_GCC_OPTION_NEW($@)],[AX_CXXFLAGS_GCC_OPTION_OLD($@)])])

=== added file 'm4/ax_cflags_warn_all.m4'
--- m4/ax_cflags_warn_all.m4	1970-01-01 00:00:00 +0000
+++ m4/ax_cflags_warn_all.m4	2008-11-11 05:58:19 +0000
@@ -0,0 +1,158 @@
+##### http://autoconf-archive.cryp.to/ax_cflags_warn_all.html
+#
+# SYNOPSIS
+#
+#   AX_CFLAGS_WARN_ALL [(shellvar [,default, [A/NA]])]
+#
+# DESCRIPTION
+#
+#   Try to find a compiler option that enables most reasonable
+#   warnings. This macro is directly derived from VL_PROG_CC_WARNINGS
+#   which is split up into two AX_CFLAGS_WARN_ALL and
+#   AX_CFLAGS_WARN_ALL_ANSI
+#
+#   For the GNU CC compiler it will be -Wall (and -ansi -pedantic) The
+#   result is added to the shellvar being CFLAGS by default.
+#
+#   Currently this macro knows about GCC, Solaris C compiler, Digital
+#   Unix C compiler, C for AIX Compiler, HP-UX C compiler, IRIX C
+#   compiler, NEC SX-5 (Super-UX 10) C compiler, and Cray J90 (Unicos
+#   10.0.0.8) C compiler.
+#
+#    - $1 shell-variable-to-add-to : CFLAGS
+#    - $2 add-value-if-not-found : nothing
+#    - $3 action-if-found : add value to shellvariable
+#    - $4 action-if-not-found : nothing
+#
+# LAST MODIFICATION
+#
+#   2006-12-12
+#
+# COPYLEFT
+#
+#   Copyright (c) 2006 Guido U. Draheim <guidod@gmx.de>
+#
+#   This program is free software; you can redistribute it and/or
+#   modify it under the terms of the GNU General Public License as
+#   published by the Free Software Foundation; either version 2 of the
+#   License, or (at your option) any later version.
+#
+#   This program is distributed in the hope that it will be useful, but
+#   WITHOUT ANY WARRANTY; without even the implied warranty of
+#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+#   General Public License for more details.
+#
+#   You should have received a copy of the GNU General Public License
+#   along with this program; if not, write to the Free Software
+#   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+#   02111-1307, USA.
+#
+#   As a special exception, the respective Autoconf Macro's copyright
+#   owner gives unlimited permission to copy, distribute and modify the
+#   configure scripts that are the output of Autoconf when processing
+#   the Macro. You need not follow the terms of the GNU General Public
+#   License when using or distributing such scripts, even though
+#   portions of the text of the Macro appear in them. The GNU General
+#   Public License (GPL) does govern all other use of the material that
+#   constitutes the Autoconf Macro.
+#
+#   This special exception to the GPL applies to versions of the
+#   Autoconf Macro released by the Autoconf Macro Archive. When you
+#   make and distribute a modified version of the Autoconf Macro, you
+#   may extend this special exception to the GPL to apply to your
+#   modified version as well.
+
+AC_DEFUN([AX_CFLAGS_WARN_ALL],[dnl
+AS_VAR_PUSHDEF([FLAGS],[CFLAGS])dnl
+AS_VAR_PUSHDEF([VAR],[ac_cv_cflags_warn_all])dnl
+AC_CACHE_CHECK([m4_ifval($1,$1,FLAGS) for maximum warnings],
+VAR,[VAR="no, unknown"
+ AC_LANG_SAVE
+ AC_LANG_C
+ ac_save_[]FLAGS="$[]FLAGS"
+for ac_arg dnl
+in "-pedantic  % -Wall"       dnl   GCC
+   "-xstrconst % -v"          dnl Solaris C
+   "-std1      % -verbose -w0 -warnprotos" dnl Digital Unix
+   "-qlanglvl=ansi % -qsrcmsg -qinfo=all:noppt:noppc:noobs:nocnd" dnl AIX
+   "-ansi -ansiE % -fullwarn" dnl IRIX
+   "+ESlit     % +w1"         dnl HP-UX C
+   "-Xc        % -pvctl[,]fullmsg" dnl NEC SX-5 (Super-UX 10)
+   "-h conform % -h msglevel 2" dnl Cray C (Unicos)
+   #
+do FLAGS="$ac_save_[]FLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   AC_TRY_COMPILE([],[return 0;],
+   [VAR=`echo $ac_arg | sed -e 's,.*% *,,'` ; break])
+done
+ FLAGS="$ac_save_[]FLAGS"
+ AC_LANG_RESTORE
+])
+case ".$VAR" in
+     .ok|.ok,*) m4_ifvaln($3,$3) ;;
+   .|.no|.no,*) m4_ifvaln($4,$4,[m4_ifval($2,[
+        AC_RUN_LOG([: m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $2"])
+                      m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $2"])]) ;;
+   *) m4_ifvaln($3,$3,[
+   if echo " $[]m4_ifval($1,$1,FLAGS) " | grep " $VAR " 2>&1 >/dev/null
+   then AC_RUN_LOG([: m4_ifval($1,$1,FLAGS) does contain $VAR])
+   else AC_RUN_LOG([: m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"])
+                      m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"
+   fi ]) ;;
+esac
+AS_VAR_POPDEF([VAR])dnl
+AS_VAR_POPDEF([FLAGS])dnl
+])
+
+dnl the only difference - the LANG selection... and the default FLAGS
+
+AC_DEFUN([AX_CXXFLAGS_WARN_ALL],[dnl
+AS_VAR_PUSHDEF([FLAGS],[CXXFLAGS])dnl
+AS_VAR_PUSHDEF([VAR],[ac_cv_cxxflags_warn_all])dnl
+AC_CACHE_CHECK([m4_ifval($1,$1,FLAGS) for maximum warnings],
+VAR,[VAR="no, unknown"
+ AC_LANG_SAVE
+ AC_LANG_CPLUSPLUS
+ ac_save_[]FLAGS="$[]FLAGS"
+for ac_arg dnl
+in "-pedantic  % -Wall"       dnl   GCC
+   "-xstrconst % -v"          dnl Solaris C
+   "-std1      % -verbose -w0 -warnprotos" dnl Digital Unix
+   "-qlanglvl=ansi % -qsrcmsg -qinfo=all:noppt:noppc:noobs:nocnd" dnl AIX
+   "-ansi -ansiE % -fullwarn" dnl IRIX
+   "+ESlit     % +w1"         dnl HP-UX C
+   "-Xc        % -pvctl[,]fullmsg" dnl NEC SX-5 (Super-UX 10)
+   "-h conform % -h msglevel 2" dnl Cray C (Unicos)
+   #
+do FLAGS="$ac_save_[]FLAGS "`echo $ac_arg | sed -e 's,%%.*,,' -e 's,%,,'`
+   AC_TRY_COMPILE([],[return 0;],
+   [VAR=`echo $ac_arg | sed -e 's,.*% *,,'` ; break])
+done
+ FLAGS="$ac_save_[]FLAGS"
+ AC_LANG_RESTORE
+])
+case ".$VAR" in
+     .ok|.ok,*) m4_ifvaln($3,$3) ;;
+   .|.no|.no,*) m4_ifvaln($4,$4,[m4_ifval($2,[
+        AC_RUN_LOG([: m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $2"])
+                      m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $2"])]) ;;
+   *) m4_ifvaln($3,$3,[
+   if echo " $[]m4_ifval($1,$1,FLAGS) " | grep " $VAR " 2>&1 >/dev/null
+   then AC_RUN_LOG([: m4_ifval($1,$1,FLAGS) does contain $VAR])
+   else AC_RUN_LOG([: m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"])
+                      m4_ifval($1,$1,FLAGS)="$m4_ifval($1,$1,FLAGS) $VAR"
+   fi ]) ;;
+esac
+AS_VAR_POPDEF([VAR])dnl
+AS_VAR_POPDEF([FLAGS])dnl
+])
+
+dnl  implementation tactics:
+dnl   the for-argument contains a list of options. The first part of
+dnl   these does only exist to detect the compiler - usually it is
+dnl   a global option to enable -ansi or -extrawarnings. All other
+dnl   compilers will fail about it. That was needed since a lot of
+dnl   compilers will give false positives for some option-syntax
+dnl   like -Woption or -Xoption as they think of it is a pass-through
+dnl   to later compile stages or something. The "%" is used as a
+dnl   delimimiter. A non-option comment can be given after "%%" marks
+dnl   which will be shown but not added to the respective C/CXXFLAGS.

=== modified file 'shift.c'
--- shift.c	2008-08-14 21:24:49 +0000
+++ shift.c	2008-11-11 05:58:19 +0000
@@ -17,9 +17,14 @@
 Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301,
 USA.  */
 
+#ifdef HAVE_CONFIG_H
+#include "config.h"
+#endif
 
 #include <sys/types.h>
+#ifdef HAVE_UNISTD_H
 #include <unistd.h>
+#endif
 #include <stdio.h>
 #include "jartool.h"
 #include "shift.h"

